﻿//
//	source.cpp
//	ST_PUZZLE
//
//	Created by Eden,Pjy on 5/2/18.
//	Copyright © 2018年 author. All rights reserved.
//
//
//	用Visual Studio 2017编译之前注意事项：
//	文件属性->c/c++->预处理器->预处理器定义 中添加：
//	_CRT_SECURE_NO_DEPRECATE
//	_CRT_NONSTDC_NO_DEPRECATE
//	文件属性->c/c++->代码生成->运行库 修改为 "多线程调试 (/MTd)"
//
#include "easypaint.h"
#define ref(i,x,y)for(int i=x;i<=y;++i)
typedef long long LL;
const int ww = 768;
const int wh = 640;
const int gapwidth = 50;
const int gapheight = 30;
COLORREF brushcolor = rgb(94, 94, 78);
COLORREF backcolor = rgb(0, 92, 64);
int brushr = 3;
int eraser = 10;
const char* heiti = "黑体";
const char* courier_new = "Courier New";
const char* yahei = "微软雅黑";
const COLORREF white = rgb(255, 255, 255);
const COLORREF black = rgb(0, 0, 0);
const COLORREF darkgray = rgb(63, 63, 63);
const COLORREF lightgray = rgb(221, 221, 221);
const COLORREF gray = rgb(137, 137, 137);
const COLORREF lightlightblue = rgb(190, 250, 255);
const COLORREF lightblue = rgb(102, 204, 255);
const COLORREF lightlightgreen = rgb(200, 255, 200);
const COLORREF lightgreen = rgb(122, 255, 144);
const int blockcolor[3][2] = {
	{ gray,lightgray },
{ lightgreen,lightlightgreen },
{ lightblue,lightlightblue }
};
int read() {
	char c = getchar(); int d = 0, f = 1;
	for (; c<'0' || c>'9'; c = getchar())if (c == '-')f = -1;
	for (; c >= '0'&&c <= '9'; d = d * 10 + c - 48, c = getchar());
	return d * f;
}

void midptext(int x1, int y1, int x2, int y2, int h, int w, const char*str) {
	int x = (x1 + x2 - strlen(str)*w) / 2, y = (y1 + y2 - h) / 2;
	sett(h, w, constr(heiti)); ptext(x, y, str);
}

void colorlighter(int&r, int&g, int&b) {
	if (r < 255)r++; if (g < 255)g++; if (b < 255)b++;
}

void colordarker(int&r, int&g, int&b) {
	if (r > 0)r--; if (g > 0)g--; if (b > 0)b--;
}
void textappear(int r, int g, int b, const char* s) {
	ref(i, 1, 150) {
		colorlighter(r, g, b);
		settc(rgb(r, g, b));
		midptext(0, 0, ww, wh, 36, 18, s);
		flushpaint();
		delay(1);
	}
	ref(i, 1, 150) {
		colordarker(r, g, b);
		settc(rgb(r, g, b));
		midptext(0, 0, ww, wh, 36, 18, s);
		flushpaint();
		delay(1);
	}
}
void openning() {
	setbkc(white); cleardevice(); flushpaint();
	int r = 0, g = 92, b = 64;
	ref(i, 1, 250) {
		colorlighter(r, g, b);
		if (i % 2 == 0)continue;
		setfc(rgb(r, g, b));
		fcircle(ww / 2, wh / 2, 500 - i * 2);
	}
	delay(200);
	r = 102, g = 204, b = 255;
	ref(i, 1, 50) {
		colordarker(r, g, b);
		settc(rgb(r, g, b));
		midptext(0, 0, ww, wh, 120, 60, "ST_PUZZLE");
		flushpaint();
		delay(10);
	}
	ref(i, 1, 500) {
		if (i <= 200) {
			colorlighter(r, g, b);
			if (i % 2 > 0)continue;
		}
		else {
			if (i == 201)r = 163, g = 255, b = 227;
			if (r > 1)colordarker(r, g, b);
			if (i % 3 > 0)continue;
		}
		int r_ = 0, g_ = 92, b_ = 64;
		ref(j, 1, (500 - i) / 2) {
			colorlighter(r_, g_, b_);
			if (j % 3 > 0)continue;
			setfc(rgb(r_, g_, b_));
			fcircle(ww / 2, wh / 2, 500 - j * 2 - i);
		}
		settc(rgb(r, g, b));
		midptext(0, 0, ww, wh, 120, 60, "ST_PUZZLE");;
		flushpaint();
		delay(10);
	}
	setbkc(rgb(r, g, b));
	cleardevice();
	flushpaint();
	r = 0, g = 92, b = 64;
	textappear(r, g, b, "Powered by Easyx");
	textappear(r, g, b, "Powered by Microsoft Visual Studio 2017");
	textappear(r, g, b, "Designed by Eden, Pjy in Jan/2018");
	textappear(r, g, b, "ST_PUZZLE Edition 1.0");
}
bool vis[21][21];
int n, m, mp[21][21], dir[21][21], fdir[21][21], gw, gh, sta[401][2], top, nowx, nowy;
int pt[ww + 1][wh + 1];
string hints, title;
struct xint { int x, y; }p[21][21];
const int d[5][2] = { { 0,0 },{ 1,0 },{ 0,1 },{ -1,0 },{ 0,-1 } };
const int fd[5] = { 0,3,4,1,2 };
const bool pd[5][5] = { { 0,0,0,0,0 },{ 0,0,1,0,1 },{ 0,1,0,1,0 },{ 0,0,1,0,1 },{ 0,1,0,1,0 } };
void drawrect(int x, int y, int tp) {
	setl(0, 8); setc(white); dbar(x, y, x + gw, y + gh);
	if (tp == 1) setfc(rgb(52, 154, 205)); else
		if (tp == 2)setfc(rgb(2, 104, 155)); else
			setfc(rgb(102, 204, 255));
	fbar(x, y, x + gw, y + gh);
	switch (tp) {
	case 1: {
		settc(white); sett(gh - gh / 30, gw - gw / 3);
		ptext(x + gw / 6, y + gh / 60, "S");
		break;
	}
	case 2: {
		settc(white); sett(gh - gh / 30, gw - gw / 3);
		ptext(x + gw / 6, y + gh / 60, "T");
		break;
	}
	case 3: {
		setfc(darkgray); fcircle(x + gw / 2, y + gh / 2, min(gw, gh) / 6);
		break;
	}
	case 4: {
		setfc(lightgray); fcircle(x + gw / 2, y + gh / 2, min(gw, gh) / 6);
		break;
	}
	case 5: {
		setc(gray); pline(x + gw / 4, y + gh / 4, x + gw - gw / 4, y + gh - gh / 4); pline(x + gw - gw / 4, y + gh / 4, x + gw / 4, y + gh - gh / 4);
		break;
	}
	case 6: {
		setfc(darkgray); fcircle(x + gw / 2, y + gh / 2, min(gw, gh) / 6);
		setfc(lightgray); fcircle(x + gw / 2, y + gh / 2, min(gw, gh) / 12);
		break;
	}
	}
}
void drawdir(int x, int y, int tp) {
	if (!tp)return;
	x += gw / 2, y += gh / 2;
	int X = x, Y = y;
	switch (tp) {
	case 1:Y += gh; break;
	case 2:X += gw; break;
	case 3:Y -= gh; break;
	case 4:X -= gw; break;
	}
	setl(0, 20); setc(white); pline(x, y, X, Y);
}
void drawframe() {
	setl(0, 10); setc(white); dbar(100, 100, ww - 100, wh - 100);
}
void drawcleaner() {
	POINT s = readmousexy();
	if (s.x >= ww - 210 && s.x <= ww - 115 && s.y >= wh - 80 && s.y <= wh - 30)
		setfc(lightblue);
	else
		setfc(lightlightblue);
	fbar(ww - 210, wh - 80, ww - 115, wh - 30);
	setc(white); setl(0, 6);
	dbar(ww - 210, wh - 80, ww - 115, wh - 30);
	settc(darkgray);
	sett(30, 0, constr(heiti));
	ptext(ww - 200, wh - 70, "CLEAR");
}
void drawback() {
	POINT s = readmousexy();
	if (s.x >= 115 && s.x <= 195 && s.y >= 30 && s.y <= 80)
		setfc(lightblue);
	else
		setfc(lightlightblue);
	fbar(115, 30, 195, 80);
	setc(white); setl(0, 6);
	dbar(115, 30, 195, 80);
	settc(darkgray);
	sett(30, 0, constr(heiti));
	ptext(125, 40, "BACK");
}
void drawtitle() {
	settc(white);
	sett(50, 0, constr(yahei));
	ptext(ww - 300, 30, title.c_str());
}
void drawhints() {
	int sw = 62;
	settc(white);
	sett(20, 0, constr(yahei));
	for (int i = 0; i < hints.length(); i += sw) {
		string hint = "";
		for (int j = i; j < hints.length() && j < i + sw; ++j)hint = hint + hints[j];
		ptext(100, wh - 75 + (i / sw) * 15, hint.c_str());
	}
}
void drawpic() {
	setbkc(backcolor);
	cleardevice();
	gw = (ww - 200) / m;
	gh = (wh - 200) / n;
	ref(i, 1, n)ref(j, 1, m)drawrect((j - 1)*gw + 100, (i - 1)*gh + 100, mp[i][j]);
	ref(i, 1, n)ref(j, 1, m)drawdir((j - 1)*gw + 100, (i - 1)*gh + 100, dir[i][j]);
	setl(0, 1); setc(brushcolor);
	ref(i, 0, ww) {
		int last = 0;
		ref(j, 0, wh)if (!pt[i][j])last = j + 1; else
			if (j == wh || !pt[i][j + 1])pline(i, last, i, j);
	}
	drawframe();
	drawtitle();
	drawback();
	drawcleaner();
	drawhints();
	flushpaint();
}
void paintdot(int x, int y, int c, int r) {
	ref(i, x - r, x + r)if (i >= 0 && i < ww)
		ref(j, y - r, y + r)if (j >= 0 && j < wh)
		if (sqr(i - x) + sqr(j - y) <= r * r)pt[i][j] = c;
}
bool levelstart(int Fi, int Se, const char*str, string S) {
	while (readasynckey(VK_LBUTTON) & 0x8000)delay(1);
	memset(vis, 0, sizeof vis);
	memset(sta, 0, sizeof sta);
	memset(mp, 0, sizeof mp);
	memset(vis, 0, sizeof vis);
	memset(dir, 0, sizeof dir);
	memset(fdir, 0, sizeof fdir);
	memset(pt, 0, sizeof pt);
	top = 0;
	setbkc(backcolor);
	cleardevice();
	flushmouse();
	flushkey();
	freopen(str, "r", stdin);
	n = read(), m = read();
	ref(i, 1, n)ref(j, 1, m) mp[i][j] = read();
	fclose(stdin);
	hints = S; title = "Level " + constr(Fi) + " - " + constr(Se);
	int posx = 0, posy = 0; top = 0;
	ref(i, 1, n)ref(j, 1, m)if (mp[i][j] == 1)posx = i, posy = j, sta[++top][0] = i, sta[top][1] = j;
	ref(i, 1, n)vis[i][0] = vis[i][m + 1] = 1;
	ref(i, 1, m)vis[0][i] = vis[n + 1][i] = 1;
	vis[posx][posy] = 1;
	if (!posx || !posy)return 0;
	bool lastlbutton = 0, lastrbutton = 0;
	vector2 Llbutton, Lrbutton;
	int times = 0;
	while (1) {
		times++;
		drawpic();
		if (mp[posx][posy] == 2) {
			delay(100);
			return 1;
		}
		flushmouse();
		bool isclick = 0;
		if (readasynckey(VK_LBUTTON) & 0x8000) {
			isclick = 1;
			MOUSEMSG ms = readmouse();
			if (lastlbutton) {
				vector2 u = Llbutton, v = vector2(ms.x, ms.y), vu = v - u;
				int d = ceil(norm(vu)); vu = vu * (1.0 / d);
				ref(I, 1, d) {
					u = u + vu;
					paintdot(round(u.x), round(u.y), 1, brushr);
				}
				Llbutton = v;
			}
			lastlbutton = 1;
			Llbutton = vector2(ms.x, ms.y);
			paintdot(ms.x, ms.y, 1, brushr);
		}
		else {
			lastlbutton = 0;
			Llbutton = vector2(0, 0);
		}
		if (readasynckey(VK_RBUTTON) & 0x8000) {
			MOUSEMSG ms = readmouse();
			if (lastrbutton) {
				vector2 u = Lrbutton, v = vector2(ms.x, ms.y), vu = v - u;
				int d = ceil(norm(vu)); vu = vu * (1.0 / d);
				ref(I, 1, d) {
					u = u + vu;
					paintdot(round(u.x), round(u.y), 0, eraser);
				}
				Lrbutton = v;
			}
			lastrbutton = 1;
			Lrbutton = vector2(ms.x, ms.y);
			paintdot(ms.x, ms.y, 0, eraser);
		}
		else {
			lastrbutton = 0;
			Lrbutton = vector2(0, 0);
		}
		if (isclick) {
			POINT s = readmousexy();
			if (s.x >= ww - 210 && s.x <= ww - 115 && s.y >= wh - 80 && s.y <= wh - 30) {
				ref(i, 0, ww)ref(j, 0, wh)pt[i][j] = 0;
			}
			if (s.x >= 115 && s.x <= 195 && s.y >= 30 && s.y <= 80) {
				return 0;
			}
		}
		char c = readkeypressed();
		int x = 0;
		if (c == 27)return 0;
		if (c == 's' || c == 'S')x = 1;
		if (c == 'd' || c == 'D')x = 2;
		if (c == 'w' || c == 'W')x = 3;
		if (c == 'a' || c == 'A')x = 4;
		if (c == VK_BACK) x = 5;
		if (x) {
			if (x == 5) { if (top > 1) vis[posx][posy] = 0, top--, posx = sta[top][0], posy = sta[top][1], dir[posx][posy] = 0; }
			else
			{
				bool flag = 1;
				if (mp[posx][posy] == 3)if (!pd[fdir[posx][posy]][x])flag = 0;
				if (mp[posx][posy] == 4)if (fd[fdir[posx][posy]] != x)flag = 0;
				if (flag) {
					int Posx = posx + d[x][0], Posy = posy + d[x][1];
					bool bo = 1;
					if (mp[Posx][Posy] == 2)
					{
						ref(i, 1, n)ref(j, 1, m)
							if ((mp[i][j] == 3 || mp[i][j] == 4 || mp[i][j] == 6) && vis[i][j] == 0) bo = 0;
					}
					if (bo && !vis[Posx][Posy] && mp[Posx][Posy] != 5) {
						dir[posx][posy] = x;
						posx = Posx, posy = Posy;
						vis[posx][posy] = 1;
						fdir[posx][posy] = fd[x];
						sta[++top][0] = posx, sta[top][1] = posy;
					}
				}
			}
		}
		delay(10);
	}
}
int _N, _M[21];
int userinf[21][31];
char fstr[21][31][31]; string gstr[21][31];
void readinfo() {
	freopen(".\\level\\levelinf.txt", "r", stdin);
	scanf("%d", &_N);
	ref(i, 0, _N - 1) {
		scanf("%d", &_M[i]);
		ref(j, 0, _M[i] - 1) {
			scanf("%s\n", &fstr[i][j]);
			getline(cin, gstr[i][j]);
		}
	}
	fclose(stdin);
	if (mkfile(".\\level\\levelnow.txt")) {
		freopen(".\\level\\levelnow.txt", "w", stdout);
		int tot = 0;
		ref(i, 0, _N - 1)ref(j, 0, _M[i] - 1) {
			if (tot < 5)++tot, printf("1 "); else printf("0 ");
		}
		fclose(stdout);
	}
	freopen(".\\level\\levelnow.txt", "r", stdin);
	ref(i, 0, _N - 1)ref(j, 0, _M[i] - 1)scanf("%d", &userinf[i][j]);
	fclose(stdin);
}
void saveinfo() {
	freopen(".\\level\\levelnow.txt", "w", stdout);
	ref(i, 0, _N - 1)ref(j, 0, _M[i] - 1)printf("%d ", userinf[i][j]);
	fclose(stdout);
}
struct group {
	figure a, b;
	int x1, y1, x2, y2;
}fg[1001];
pair<int, int> lxy[1001];
int ltot; string lnm[1001];
bool lst[1001];
void showcatalog() {
showcatalog_:
	ltot = 0;
	ref(i, 0, _N - 1)ref(j, 0, _M[i] - 1)
		lxy[ltot++] = make_pair(i, j);
	ref(i, 0, ltot - 1) {
		int ix = lxy[i].first, iy = lxy[i].second;
		fg[i].a.clear(); fg[i].b.clear();
		fg[i].x1 = (i % 3) * (ww - gapwidth) / 3 + gapwidth;
		fg[i].x2 = (i % 3 + 1)*(ww - gapwidth) / 3;
		int bw = fg[i].x2 - fg[i].x1;
		int bh = 100;
		fg[i].y1 = i / 3 * (gapheight + bh) + gapheight;
		fg[i].y2 = (i / 3 + 1)*(gapheight + bh);
		int uif = userinf[ix][iy];
		int bc0 = blockcolor[uif][0], bc1 = blockcolor[uif][1];
		lnm[i] = constr(ix) + "-" + constr(iy);
		int tx = (fg[i].x1 + fg[i].x2) / 2 - 15 * lnm[i].length();
		int ty = (fg[i].y1 + fg[i].y2) / 2 - 30;
		fg[i].a.insert(sdbar(0, 6, white, fg[i].x1, fg[i].y1, fg[i].x2, fg[i].y2));
		fg[i].a.insert(sfbar(bc0, fg[i].x1, fg[i].y1, fg[i].x2, fg[i].y2));
		fg[i].a.insert(sptext(60, 0, constr(heiti), darkgray, tx, ty, lnm[i].c_str()));
		fg[i].b.insert(sdbar(0, 6, white, fg[i].x1, fg[i].y1, fg[i].x2, fg[i].y2));
		fg[i].b.insert(sfbar(bc1, fg[i].x1, fg[i].y1, fg[i].x2, fg[i].y2));
		fg[i].b.insert(sptext(60, 0, constr(heiti), darkgray, tx, ty, lnm[i].c_str()));
	}
	setbkc(backcolor);
	cleardevice();
	flushmouse();
	flushkey();
	ref(i, 0, ltot - 1)fg[i].a.paint();
	flushpaint();
	memset(lst, 0, sizeof lst);
	int vy = 0, sy = 0;
	while (1) {
		flushmouse();
		POINT ms = readmousexy();
		MOUSEMSG MS = readmouse();
		UINT uMsg = MS.uMsg;
		vy = MS.wheel / 120 * 50;
		if (vy != 0 && sy + vy >= -800 && sy + vy <= 0) {
			setbkc(backcolor);
			cleardevice();
			sy += vy;
			ref(i, 0, ltot - 1) {
				fg[i].y1 += vy;
				fg[i].y2 += vy;
				if (lst[i])fg[i].b.paint(vector2(0, sy));
				else fg[i].a.paint(vector2(0, sy));
			}
			flushpaint();
		}
		bool isclick = uMsg == WM_LBUTTONDOWN;
		ref(i, 0, ltot - 1) {
			bool nst = (fg[i].x1 <= ms.x&&ms.x <= fg[i].x2&&fg[i].y1 <= ms.y&&ms.y <= fg[i].y2);
			if (nst^lst[i]) {
				lst[i] = nst;
				if (nst)fg[i].b.paint(vector2(0, sy));
				else fg[i].a.paint(vector2(0, sy));
				flushpaint();
			}
			int ix = lxy[i].first, iy = lxy[i].second;
			if (nst&&isclick&&userinf[ix][iy] != 0) {
				while (levelstart(ix, iy, fstr[ix][iy], gstr[ix][iy])) {
					if (userinf[ix][iy] != 2) {
						userinf[ix][iy] = 2;
						ref(I, 0, _N)ref(J, 0, _M[I] - 1)if (userinf[I][J] == 0) {
							userinf[I][J] = 1; break;
						}
						saveinfo();
					}
					iy++; if (iy >= _M[ix])ix++, iy = 0;
					if (ix >= _N)break;
				}
				goto showcatalog_;
			}
		}
		delay(10);
	}
}
void MAIN() {
	openning();
	readinfo();
	showcatalog();
	saveinfo();
}
int main(int argc, char *argv[]) {
	createg(ww, wh);
	beginpaint();
	MAIN();
	cleardevice();
	endpaint();
	return 0;
}